//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//         File: footer.js
//  Description: 
//       Author: Davidovich V. (ringo@g5software.com)

var defaultTabIndex = 1;
var backButton;

function showBack() 
{
  backButton.style.display = 'block';

  // $HACK can't make onstorage work on iphone
  handleStorageEvent();
}

function hideBack() 
{
  backButton.style.display = 'none';
}

var tabs;

function setTab(tab)
{
  // Remove classes from other active nodes
  for (var k = 0, l = tabs.length; k < l; k++)
    removeClass(tabs[k], "active");
          
  // Add active to self
  if (tab)
    addClass(tab, "active");

  // $HACK can't make onstorage work on iphone
  handleStorageEvent();
}

var badgeNews;

function setBadgeNewsValue(_value)
{
  if (!badgeNews)
    return;
    
  badgeNews.style.display = (_value && _value != 0) ? 'block' : 'none';
  badgeNews.innerHTML     = _value;
}

function handleStorageEvent()
{ 
  setBadgeNewsValue(window.localStorage.getItem("xpromo.news.unread"));
}

function init()
{
  backButton = document.getElementById("backButton");
  hideBack();  

  badgeNews = document.querySelector("li.news span");
  handleStorageEvent();

  // download data
  newsFetch(function(xpromoNews)
  {
    handleStorageEvent();
  });

  tabs = nativeFooter();
  addClass(tabs[defaultTabIndex], "active");
}

// Mimic native footer UI
function nativeFooter()
{
  // Target element
  var footer = document.querySelector("#footer");
  if (footer) 
  {
    // Prevent scrolling on this element
    footer.ontouchmove = 
      function(event)
      {
        event.preventDefault();
      }

    // Grab all 'tabs'
    var tabs = footer.getElementsByTagName("li");
    for (var i = 0, j = tabs.length; i < j; i++) 
    {
      var tab = tabs[i];
      
      // Add active class on touch
      tab.addEventListener("click", 
        function() 
        {
          setTab(this);
        }, false);
    }

    return tabs;
  }
}

// Fire on load
window.addEventListener("load", init, false);
