//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//         File: games.js
//  Description: 
//       Author: Davidovich V. (ringo@g5software.com)

var GAMES_NEW_DATE = new Date((new Date().getTime()) - 1000 * 60 * 60 * 24 * 60);

with (window.localStorage)
{
  if (null == getItem("xpromo"))
  {
    setItem("xpromo",             "test");
    setItem("xpromo.id",          "com.g5e.xpromodemo");
    setItem("xpromo.games.count", "18");
    setItem("xpromo.games.0.id",  "com.g5e.crystalportal");
    setItem("xpromo.games.1.id",  "com.g5e.crystalportal2");
    setItem("xpromo.games.2.id",  "com.g5e.mahjonga1");
    setItem("xpromo.games.3.id",  "com.g5e.mahjonga2");
    setItem("xpromo.games.4.id",  "com.g5e.mushroomage");
    setItem("xpromo.games.5.id",  "com.g5e.paranormal");
    setItem("xpromo.games.6.id",  "com.g5e.romanceofrome");
    setItem("xpromo.games.7.id",  "com.g5e.sm");
    setItem("xpromo.games.8.id",  "com.g5e.smm");
    setItem("xpromo.games.9.id",  "com.g5e.sstory");
    setItem("xpromo.games.10.id", "com.g5e.standofood");
    setItem("xpromo.games.11.id", "com.g5e.treasures1");
    setItem("xpromo.games.12.id", "com.g5e.treasures2");
    setItem("xpromo.games.13.id", "com.g5e.virtualcity");
    setItem("xpromo.games.14.id", "com.kranx.yumsters2");
    setItem("xpromo.games.15.id", "com.realore.aquapearls");
    setItem("xpromo.games.16.id", "com.realore.janeshotel");
    setItem("xpromo.games.17.id", "com.realore.janeszoo");
    /*
    setItem("xpromo.games.count", "7");
    setItem("xpromo.games.0.id", "com.g5e.mahjonga2.mac");
    setItem("xpromo.games.1.id", "com.g5e.mahjonga1.mac");
    setItem("xpromo.games.2.id", "com.g5e.paranormal.mac");
    setItem("xpromo.games.3.id", "com.g5e.virtualcity.mac");
    setItem("xpromo.games.4.id", "com.g5e.smm.mac");
    setItem("xpromo.games.5.id", "com.g5e.standofood.mac");
    setItem("xpromo.games.6.id", "com.g5e.sstory.mac");
    */
  }
}

var dataRecommended = {};
var dataMore        = {};
var dataNew         = {};

var gamesDirective = 
{
  "li" : 
  {
    "game<-games" : 
    {
      "@class+"   : "game.kind",
      "a+"        : "game.name",
      "+a@href"   : "game.id",
      "div@style" : function(arg) { return "background-image: url('" + arg.item.id + "/icon.png')"; }
    }
  }
}

for (id in xpromoGames)
{
  try
  {
    var game  = xpromoGames[id];

    game.id   = id;
    game.date = new Date(game.date);

    if (game.date > GAMES_NEW_DATE)
      game.kind = "new";

    if (!("doomed" in game))
      game.doomed = false;
  }
  catch (e)
  {
    delete xpromoGames[id];
  }
}

function gamesInit(_table)
{
  var games = new Array(parseInt(window.localStorage.getItem("xpromo.games.count")));
  for (var i = 0; i < games.length; i++)
  {
    var id   = window.localStorage.getItem("xpromo.games." + i + ".id");
    var game = (games[i] = _table[id]);

    if (!game || !(lockit = lockitLoad(id + "/index")))
      console.log("not found: " + id);
    else
    {
      game.name = lockit["title"];
    }
  }

  // filter unavailable games
  games = games.filter(function(element, index, array)
  {
    return element != null;
  });

  // apply include/exclude lists
  if (xpromoRecommended = window.localStorage.getItem("xpromo.recommended"))
  {
    xpromoRecommended = JSON.parse(xpromoRecommended);

    games = games.filter(function(element, index, array)
    {
      return -1 == xpromoRecommended.exclude.indexOf(element.id);
    });

    games.sort(function(a, b)
    {
      var inc  = xpromoRecommended.include;

      var idxA = inc.indexOf(a.id);
      if (idxA == -1)
        idxA = inc.length;

      var idxB = inc.indexOf(b.id);
      if (idxB == -1)
        idxB = inc.length;

      return idxA - idxB;
    });
  }

  dataRecommended.games = games.slice(0, 3);
  dataMore.games        = games.slice(3);
  dataNew.games         = games.slice(3);

  dataNew.games.sort(function(a, b)
  {
    b = b.doomed ? new Date(0) : b.date;
    a = a.doomed ? new Date(0) : a.date;

    return b - a;
  });

  // move 3 newest games from dataMore to dataNew
  dataNew.games  = dataNew.games.splice(0, 3);
  dataMore.games = dataMore.games.filter(function(element, index, array) 
  {
    return -1 == dataNew.games.indexOf(element);
  });

  return games;
}

function gamesRender()
{
  gamesInit(xpromoGames);

  $p("h4#Recommended + ul").autoRender(dataRecommended, gamesDirective);
  $p("h4#More + ul").autoRender(dataMore, gamesDirective);
  $p("h4#New + ul").autoRender(dataNew, gamesDirective);

  if (dataMore.games.length == 0)
  {
    var section = $p("h4#More")[0];
    section.parentNode.removeChild(section);
  }
}

// fetch recommended lists
with (new XMLHttpRequest())
{
  var id   = window.localStorage.getItem("xpromo.id");
  var udid = window.localStorage.getItem("xpromo.udid");

  open("GET", "http://xpromo.g5e.com/v1/service/recommend.php?id=" + id + "&udid=" + udid);
  onreadystatechange = function()
  {
    if (readyState != 4)
      return;

    if (status == 200 ||
        responseText) // for local GET to work
    {
      if (JSON.parse(responseText))
        window.localStorage.setItem("xpromo.recommended", responseText);
    }
  }
  send(null);
}
