//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//         File: news.js
//  Description: 
//       Author: Davidovich V. (ringo@g5software.com)

var NEWS_ONE_HEIGHT = (window.innerHeight > 300) ? 90 : 45;
var NEWS_MAX_SHOWN  = Math.floor(window.innerHeight / NEWS_ONE_HEIGHT) - 1;

with (window.localStorage)
{
  if (!getItem("xpromo.news.read"))
    setItem("xpromo.news.read", "");
}

var dataNews = {}
var newsDirective = 
{
  "li.load" : 
  {
    "new<-news" : 
    {
      "@id"     : "new.id",
      "@class"  : "new.kind",
      "a"       : "new.name",
      "a@href"  : "new.href"
    }
  }
}

function newsLocalized(_lang, _stringObject)
{
  return (_lang in _stringObject) ? _stringObject[_lang] : _stringObject["en"];
}

function newsInit(_table)
{
  dataNews.news = {};

  var lang = lockitGetLang();

  var i = 0;
  for (var id in _table)
  {
    if (i++ >= NEWS_MAX_SHOWN)
      break;

    var news = dataNews.news[id] = _table[id];

    if (typeof(news.name) != "string")
      news.name = newsLocalized(lang, news.name);

    if (typeof(news.href) != "string")
      news.href = newsLocalized(lang, news.href);

    news.href = NEWS_SITE + news.href;

    delete _table[id];
  }

  if (i > NEWS_MAX_SHOWN)
  {
    dataNews.news["more"] = 
    {
      "name" : lockit["li.more a"],
      "href" : "javascript:newsMore()",
      "kind" : "more"
    };
  }

  dataNews.more = _table;
}

function newsRender()
{
  $p("ul").autoRender(dataNews, newsDirective);

  var unread = $p("li.unrd");
  for (var i = 0; i < unread.length; i++)
  {
    unread[i].onclick = function()
    { 
      this.onclick   = null;
      this.className = "read";

      var newsRead = window.localStorage.getItem("xpromo.news.read");
      newsRead += this.id + ";";
      window.localStorage.setItem("xpromo.news.read", newsRead);

      var newsUnread = window.localStorage.getItem("xpromo.news.unread");
      newsUnread -= 1;
      window.localStorage.setItem("xpromo.news.unread", newsUnread);
    }
  }
}

function newsMore()
{
  $p("li.more")[0].className = "load";
  newsInit(dataNews.more);
  window.setTimeout(newsRender, 500);
}

// download data
newsFetch(function(xpromoNews)
{
  newsInit(xpromoNews);

  window.onload = newsRender;
  if (document.readyState == 'complete')
    newsRender();
});
